<?php
class ControllerExtensionCiCustomerGroupProduct extends Controller {
	private $error = array();

	private $module_token = '';
	private $ci_token = '';

	public function __construct($registry) {
		parent :: __construct($registry);

		if(VERSION <= '2.3.0.2') {
			$this->module_token = 'token';
			$this->ci_token = $this->session->data['token'];
		} else {
			$this->module_token = 'user_token';
			$this->ci_token = $this->session->data['user_token'];
		}

		if(VERSION <= '2.0.3.1') {
			$this->load->model('sale/customer_group');
			$this->customer_groups = $this->model_sale_customer_group->getCustomerGroups();
		} else {
			$this->load->model('customer/customer_group');
			$this->customer_groups = $this->model_customer_customer_group->getCustomerGroups();
		}

		$this->load->model('extension/ci_customer_group_product');
		$this->model_extension_ci_customer_group_product->BuildCiGroupsProduct();
	}

	public function index() {
		$this->document->addStyle('view/stylesheet/cigroupproduct/style.css');

		$this->load->language('extension/ci_customer_group_product');

		$this->document->setTitle($this->language->get('heading_title'));

		$data['heading_title'] = $this->language->get('heading_title');

		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');

		$data['entry_customer_group'] = $this->language->get('entry_customer_group');
		$data['entry_base_price'] = $this->language->get('entry_base_price');
		$data['entry_type'] = $this->language->get('entry_type');
		$data['entry_value'] = $this->language->get('entry_value');
		$data['entry_action'] = $this->language->get('entry_action');
		$data['entry_custom_price'] = $this->language->get('entry_custom_price');
		$data['entry_fixed_amount'] = $this->language->get('entry_fixed_amount');
		$data['entry_percentage'] = $this->language->get('entry_percentage');
		$data['entry_all_products'] = $this->language->get('entry_all_products');
		$data['entry_custom_products'] = $this->language->get('entry_custom_products');
		$data['entry_categories'] = $this->language->get('entry_categories');
		$data['entry_manufacturers'] = $this->language->get('entry_manufacturers');
		$data['entry_manufacturer'] = $this->language->get('entry_manufacturer');
		$data['entry_update_existing'] = $this->language->get('entry_update_existing');
		$data['entry_template_name'] = $this->language->get('entry_template_name');

		$data['help_update_existing'] = $this->language->get('help_update_existing');
		$data['help_exclude_product'] = $this->language->get('help_exclude_product');

		$data['text_select_all'] = $this->language->get('text_select_all');
		$data['text_unselect_all'] = $this->language->get('text_unselect_all');
		$data['text_loading'] = $this->language->get('text_loading');
		$data['text_ignore'] = $this->language->get('text_ignore');
		$data['text_inserted'] = $this->language->get('text_inserted');
		$data['text_updated'] = $this->language->get('text_updated');
		$data['text_skip'] = $this->language->get('text_skip');
		$data['text_reason'] = $this->language->get('text_reason');
		$data['text_choose'] = $this->language->get('text_choose');
		$data['text_choose_option'] = $this->language->get('text_choose_option');
		$data['text_action_customer_group'] = $this->language->get('text_action_customer_group');
		$data['text_applyon_catalog'] = $this->language->get('text_applyon_catalog');
		$data['text_select_all_cg'] = $this->language->get('text_select_all_cg');

		$data['text_yes'] = $this->language->get('text_yes');
		$data['text_no'] = $this->language->get('text_no');

		$data['entry_store'] = $this->language->get('entry_store');
		$data['entry_category'] = $this->language->get('entry_category');
		$data['entry_product'] = $this->language->get('entry_product');
		$data['entry_format'] = $this->language->get('entry_format');
		$data['entry_filter_type'] = $this->language->get('entry_filter_type');
		$data['entry_option'] = $this->language->get('entry_option');
		$data['entry_all_options'] = $this->language->get('entry_all_options');
		$data['entry_custom_options'] = $this->language->get('entry_custom_options');
		$data['entry_exclude_product'] = $this->language->get('entry_exclude_product');

		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');
		$data['button_apply'] = $this->language->get('button_apply');
		$data['button_delete'] = $this->language->get('button_delete');
		$data['button_product_list'] = $this->language->get('button_product_list');

		$data['tab_export'] = $this->language->get('tab_export');
		$data['tab_import'] = $this->language->get('tab_import');
		$data['tab_support'] = $this->language->get('tab_support');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', $this->module_token .'=' . $this->ci_token, true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/ci_customer_group_product', $this->module_token .'=' . $this->ci_token, true)
		);

		$data['action'] = $this->url->link('extension/ci_customer_group_product', $this->module_token .'=' . $this->ci_token, true);

		$data['product_list'] = $this->url->link('extension/ci_customer_group_product/getlist', $this->module_token .'=' . $this->ci_token, true);

		$data['cancel'] = $this->url->link('extension/extension', $this->module_token .'=' . $this->ci_token . '&type=module', true);

		$this->load->model('setting/setting');
		$setting = $this->model_setting_setting->getSetting('cigroupproduct');

		$data['cigroupproduct_status'] = isset($setting['cigroupproduct_status']) ? $setting['cigroupproduct_status'] : array();
		$data['cigroupproduct_filter_type'] = isset($setting['cigroupproduct_filter_type']) ? $setting['cigroupproduct_filter_type'] : 'all';
		$data['cigroupproduct_update_existing'] = isset($setting['cigroupproduct_update_existing']) ? $setting['cigroupproduct_update_existing'] : '1';

		$data['products'] = array();
		$this->load->model('catalog/product');
		$products = isset($setting['cigroupproduct_filter_products']) ? $setting['cigroupproduct_filter_products'] : array();
		foreach ($products as $product_id) {
			$product_info = $this->model_catalog_product->getProduct($product_id);

			if ($product_info) {
				$data['products'][] = array(
					'product_id' => $product_info['product_id'],
					'name'       => $product_info['name']
				);
			}
		}

		$data['exclude_products'] = array();
		$exclude_products = isset($setting['cigroupproduct_filter_exclude_products']) ? $setting['cigroupproduct_filter_exclude_products'] : array();
		foreach ($exclude_products as $product_id) {
			$product_info = $this->model_catalog_product->getProduct($product_id);

			if ($product_info) {
				$data['exclude_products'][] = array(
					'product_id' => $product_info['product_id'],
					'name'       => $product_info['name']
				);
			}
		}


		if(isset($setting) && !empty($setting)) {
			$data['delete_action'] = true;
		}else{
			$data['delete_action'] = false;
		}

		$data['filter_categories'] = isset($setting['cigroupproduct_categories']) ? $setting['cigroupproduct_categories'] : array();
		$data['filter_manufacturers'] = isset($setting['cigroupproduct_manufacturers']) ? $setting['cigroupproduct_manufacturers'] : array();

		// Stores
		$this->load->model('setting/store');

		$data['stores'] = array();

		$data['stores'][] = array(
			'store_id' => 0,
			'name'     => $this->language->get('text_default'),
		);

		$stores = $this->model_setting_store->getStores();

		foreach ($stores as $store) {
			$data['stores'][] = array(
				'store_id' => $store['store_id'],
				'name'     => $store['name'],
			);
		}

		$data['customer_groups'] = $this->customer_groups;

		$this->load->model('catalog/category');

		$data['categories'] = $this->model_catalog_category->getCategories(array('sort' => 'name'));

		$this->load->model('catalog/manufacturer');

		$data['manufacturers'] = $this->model_catalog_manufacturer->getManufacturers();

		$data['ci_token'] = $this->ci_token;
		$data['module_token'] = $this->module_token;

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		if(VERSION <= '2.3.0.2') {
			$this->response->setOutput($this->load->view('extension/ci_customer_group_product.tpl', $data));
		} else {
			$file_variable = 'template_engine';
			$file_type = 'template';
			$this->config->set($file_variable, $file_type);
			$this->response->setOutput($this->load->view('extension/ci_customer_group_product', $data));
		}
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'extension/ci_customer_group_product')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		return !$this->error;
	}

	public function save() {
		$this->load->language('extension/ci_customer_group_product');
		$this->load->model('setting/setting');

		$json = array();

		if (!$this->user->hasPermission('modify', 'extension/ci_customer_group_product')) {
			$json['error']['warning'] = $this->language->get('error_permission');
		}

		if ($this->request->server['REQUEST_METHOD'] == 'POST') {
			if(!isset($json['error'])) {
				$this->model_setting_setting->editSetting('cigroupproduct', $this->request->post);
				$json['success'] = $this->language->get('text_setting_success');
			}
		}

		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
	}

	public function apply() {
		$this->load->language('extension/ci_customer_group_product');
		$this->load->model('extension/ci_customer_group_product');
		$this->load->model('setting/setting');

		$json = array();

		if (!$this->user->hasPermission('modify', 'extension/ci_customer_group_product')) {
			$json['error']['warning'] = $this->language->get('error_permission');
		}

		if ($this->request->server['REQUEST_METHOD'] == 'POST') {
			if ($this->request->post['cigroupproduct_filter_type'] == 'custom_product') {
				if(!isset($this->request->post['cigroupproduct_filter_products'])) {
					$json['error']['no_selected_product'] = $this->language->get('error_no_selected_product');
				}
			} elseif ($this->request->post['cigroupproduct_filter_type'] == 'custom_category') {
				if(!isset($this->request->post['cigroupproduct_categories'])) {
					$json['error']['no_selected_category'] = $this->language->get('error_no_selected_category');
				}
			} elseif ($this->request->post['cigroupproduct_filter_type'] == 'custom_manufacturer') {
				if(!isset($this->request->post['cigroupproduct_manufacturers'])) {
					$json['error']['no_selected_manufacturer'] = $this->language->get('error_no_selected_manufacturer');
				}
			}

			if(!isset($json['error'])) {
				$detectupdateproduct = $this->model_extension_ci_customer_group_product->updateProduct($this->request->post);
				//$this->model_setting_setting->editSetting('cigroupproduct', $this->request->post);
				if ($detectupdateproduct) {
					$json['success'] = $this->language->get('text_success');
				} else {
					$json['error']['warning'] = $this->language->get('text_no_action');
				}
			}
		}

		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
	}

	public function getlist() {
		$this->load->language('catalog/product');
		$this->load->language('extension/ci_customer_group_product_list');
		$this->load->model('extension/ci_customer_group_product');

		$this->document->addStyle('view/stylesheet/cigroupproduct/style.css');
		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('catalog/product');

		if (isset($this->request->get['filter_name'])) {
			$filter_name = $this->request->get['filter_name'];
		} else {
			$filter_name = null;
		}

		if (isset($this->request->get['filter_model'])) {
			$filter_model = $this->request->get['filter_model'];
		} else {
			$filter_model = null;
		}

		if (isset($this->request->get['filter_status'])) {
			$filter_status = $this->request->get['filter_status'];
		} else {
			$filter_status = null;
		}

		if (isset($this->request->get['filter_customer_group'])) {
			$filter_customer_group = $this->request->get['filter_customer_group'];
		} else {
			$filter_customer_group = null;
		}

		if (isset($this->request->get['sort'])) {
			$sort = $this->request->get['sort'];
		} else {
			$sort = 'pd.name';
		}

		if (isset($this->request->get['order'])) {
			$order = $this->request->get['order'];
		} else {
			$order = 'ASC';
		}

		if (isset($this->request->get['page'])) {
			$page = $this->request->get['page'];
		} else {
			$page = 1;
		}

		$url = '';

		if (isset($this->request->get['filter_name'])) {
			$url .= '&filter_name=' . urlencode(html_entity_decode($this->request->get['filter_name'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset($this->request->get['filter_model'])) {
			$url .= '&filter_model=' . urlencode(html_entity_decode($this->request->get['filter_model'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset($this->request->get['filter_price'])) {
			$url .= '&filter_price=' . $this->request->get['filter_price'];
		}

		if (isset($this->request->get['filter_quantity'])) {
			$url .= '&filter_quantity=' . $this->request->get['filter_quantity'];
		}

		if (isset($this->request->get['filter_status'])) {
			$url .= '&filter_status=' . $this->request->get['filter_status'];
		}

		if (isset($this->request->get['filter_image'])) {
			$url .= '&filter_image=' . $this->request->get['filter_image'];
		}

		if (isset($this->request->get['sort'])) {
			$url .= '&sort=' . $this->request->get['sort'];
		}

		if (isset($this->request->get['order'])) {
			$url .= '&order=' . $this->request->get['order'];
		}

		if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}

		$data['bulk_update'] = $this->url->link('extension/ci_customer_group_product', $this->module_token .'=' . $this->ci_token, true);
		$data['delete'] = $this->url->link('catalog/product/delete', $this->module_token .'=' . $this->ci_token, true);

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', $this->module_token .'=' . $this->ci_token, true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('bulk_update_heading_title'),
			'href' => $this->url->link('extension/ci_customer_group_product', $this->module_token .'=' . $this->ci_token, true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/ci_customer_group_product/getlist', $this->module_token .'=' . $this->ci_token . $url, true)
		);

		$data['products'] = array();

		$filter_data = array(
			'filter_name'	  => $filter_name,
			'filter_model'	  => $filter_model,
			'filter_status'   => $filter_status,
			'filter_customer_group'   => $filter_customer_group,
			'sort' 			  => $sort,
			'order' 		  => $order,
			'page'            => $page,
			'start'           => ($page - 1) * $this->config->get('config_limit_admin'),
			'limit'           => $this->config->get('config_limit_admin')
		);

		$this->load->model('tool/image');

		$product_total = $this->model_extension_ci_customer_group_product->getAllTotalProducts($filter_data);

		$results = $this->model_extension_ci_customer_group_product->getAllProducts($filter_data);

		foreach ($results as $result) {
			$cigroup_product = $this->model_catalog_product->getCiGroupsProduct($result['product_id']);

			if (is_file(DIR_IMAGE . $result['image'])) {
				$image = $this->model_tool_image->resize($result['image'], 40, 40);
			} else {
				$image = $this->model_tool_image->resize('no_image.png', 40, 40);
			}

			$special = false;

			$product_specials = $this->model_catalog_product->getProductSpecials($result['product_id']);

			foreach ($product_specials  as $product_special) {
				if (($product_special['date_start'] == '0000-00-00' || strtotime($product_special['date_start']) < time()) && ($product_special['date_end'] == '0000-00-00' || strtotime($product_special['date_end']) > time())) {
					$special = $product_special['price'];

					break;
				}
			}

			$data['products'][] = array(
				'product_id' => $result['product_id'],
				'image'      => $image,
				'name'       => $result['name'],
				'model'      => $result['model'],
				'price'      => $result['price'],
				'special'    => $special,
				'cigroup_product'   => $cigroup_product,
				'status'     => $result['status'] ? $this->language->get('text_enabled') : $this->language->get('text_disabled'),
				'edit'       => $this->url->link('catalog/product/edit', $this->module_token .'=' . $this->ci_token . '&product_id=' . $result['product_id'] . '&cigroup_product=1' . $url, true)
			);
		}

		$data['heading_title'] = $this->language->get('heading_title');

		$data['text_list'] = $this->language->get('text_list');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['text_no_results'] = $this->language->get('text_no_results');
		$data['text_confirm'] = $this->language->get('text_confirm');

		$data['column_image'] = $this->language->get('column_image');
		$data['column_name'] = $this->language->get('column_name');
		$data['column_model'] = $this->language->get('column_model');
		$data['column_price'] = $this->language->get('column_price');
		$data['column_quantity'] = $this->language->get('column_quantity');
		$data['column_status'] = $this->language->get('column_status');
		$data['column_action'] = $this->language->get('column_action');
		$data['column_customer_group'] = $this->language->get('column_customer_group');

		$data['entry_name'] = $this->language->get('entry_name');
		$data['entry_model'] = $this->language->get('entry_model');
		$data['entry_price'] = $this->language->get('entry_price');
		$data['entry_quantity'] = $this->language->get('entry_quantity');
		$data['entry_status'] = $this->language->get('entry_status');
		$data['entry_image'] = $this->language->get('entry_image');
		$data['entry_customer_group'] = $this->language->get('entry_customer_group');

		$data['button_copy'] = $this->language->get('button_copy');
		$data['button_add'] = $this->language->get('button_add');
		$data['button_edit'] = $this->language->get('button_edit');
		$data['button_delete'] = $this->language->get('button_delete');
		$data['button_filter'] = $this->language->get('button_filter');
		$data['button_bulk_update'] = $this->language->get('button_bulk_update');

		$data['ci_token'] = $this->ci_token;
		$data['module_token'] = $this->module_token;

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->session->data['success'])) {
			$data['success'] = $this->session->data['success'];

			unset($this->session->data['success']);
		} else {
			$data['success'] = '';
		}

		if (isset($this->request->post['selected'])) {
			$data['selected'] = (array)$this->request->post['selected'];
		} else {
			$data['selected'] = array();
		}

		$url = '';

		if (isset($this->request->get['filter_name'])) {
			$url .= '&filter_name=' . urlencode(html_entity_decode($this->request->get['filter_name'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset($this->request->get['filter_model'])) {
			$url .= '&filter_model=' . urlencode(html_entity_decode($this->request->get['filter_model'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset($this->request->get['filter_price'])) {
			$url .= '&filter_price=' . $this->request->get['filter_price'];
		}

		if (isset($this->request->get['filter_quantity'])) {
			$url .= '&filter_quantity=' . $this->request->get['filter_quantity'];
		}

		if (isset($this->request->get['filter_status'])) {
			$url .= '&filter_status=' . $this->request->get['filter_status'];
		}

		if (isset($this->request->get['filter_image'])) {
			$url .= '&filter_image=' . $this->request->get['filter_image'];
		}

		if ($order == 'ASC') {
			$url .= '&order=DESC';
		} else {
			$url .= '&order=ASC';
		}

		if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}

		$data['sort_name'] = $this->url->link('extension/ci_customer_group_product/getlist', $this->module_token .'=' . $this->ci_token . '&sort=pd.name' . $url, true);
		$data['sort_model'] = $this->url->link('extension/ci_customer_group_product/getlist', $this->module_token .'=' . $this->ci_token . '&sort=p.model' . $url, true);
		$data['sort_price'] = $this->url->link('extension/ci_customer_group_product/getlist', $this->module_token .'=' . $this->ci_token . '&sort=p.price' . $url, true);
		$data['sort_quantity'] = $this->url->link('extension/ci_customer_group_product/getlist', $this->module_token .'=' . $this->ci_token . '&sort=p.quantity' . $url, true);
		$data['sort_status'] = $this->url->link('extension/ci_customer_group_product/getlist', $this->module_token .'=' . $this->ci_token . '&sort=p.status' . $url, true);
		$data['sort_order'] = $this->url->link('extension/ci_customer_group_product/getlist', $this->module_token .'=' . $this->ci_token . '&sort=p.sort_order' . $url, true);

		$pagination = new Pagination();
		$pagination->total = $product_total;
		$pagination->page = $page;
		$pagination->limit = $this->config->get('config_limit_admin');
		$pagination->url = $this->url->link('extension/ci_customer_group_product/getlist', $this->module_token .'=' . $this->ci_token . $url . '&page={page}', true);

		$data['pagination'] = $pagination->render();

		$data['results'] = sprintf($this->language->get('text_pagination'), ($product_total) ? (($page - 1) * $this->config->get('config_limit_admin')) + 1 : 0, ((($page - 1) * $this->config->get('config_limit_admin')) > ($product_total - $this->config->get('config_limit_admin'))) ? $product_total : ((($page - 1) * $this->config->get('config_limit_admin')) + $this->config->get('config_limit_admin')), $product_total, ceil($product_total / $this->config->get('config_limit_admin')));

		$data['filter_name'] = $filter_name;
		$data['filter_model'] = $filter_model;
		$data['filter_status'] = $filter_status;
		$data['filter_customer_group'] = $filter_customer_group;
		$data['sort'] = $sort;
		$data['order'] = $order;

		$data['customer_groups'] = $this->customer_groups;

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		if(VERSION <= '2.3.0.2') {
			$this->response->setOutput($this->load->view('extension/ci_customer_group_product_list.tpl', $data));
		} else {
			$file_variable = 'template_engine';
			$file_type = 'template';
			$this->config->set($file_variable, $file_type);
			$this->response->setOutput($this->load->view('extension/ci_customer_group_product_list', $data));
		}
	}
}