<?php
class ControllerPossettingCategorysale extends Controller {
 	private $error = array();
	public function index() {
			
		$this->load->language('possetting/category_sale');
		
		$this->document->setTitle($this->language->get('heading_title'));
		
		$this->load->model('possetting/category_sale');
		$this->load->model('possetting/commission_report');
		
		$this->getList();
	}

 	public function getList() {
		$this->load->language('possetting/category_sale');

		if (isset($this->request->get['filter_category'])) {
			$filter_category = $this->request->get['filter_category'];
		} else {
			$filter_category = null;
		}

	
		if (isset($this->request->get['filter_posuser'])) {
			$filter_posuser = $this->request->get['filter_posuser'];
		} else {
			$filter_posuser = null;
		}

		if (isset($this->request->get['filter_date_form'])) {
			$filter_date_form = $this->request->get['filter_date_form'];
		} else {
			$filter_date_form = null;
		}

		if (isset($this->request->get['filter_date_to'])) {
			$filter_date_to = $this->request->get['filter_date_to'];
		} else {
			$filter_date_to = null;
		}

		if (isset($this->request->get['filter_product'])) {
			$filter_product = $this->request->get['filter_product'];
		} else {
			$filter_product = null;
		}
		
		if (isset($this->request->get['sort'])) {
			$sort = $this->request->get['sort'];
		} else {
		 	$sort = 'order_id';
		}
	 
		if (isset($this->request->get['order'])) {
			$order = $this->request->get['order'];
		} else {
		 	$order = 'DESC';
		}
	 
		if (isset($this->request->get['page'])) {
			$page = $this->request->get['page'];
		} else {
			$page = 1;
		}

		$url = '';

		if (isset($this->request->get['sort'])) {
			$url .= '&sort=' . $this->request->get['sort'];
		}
		if (isset($this->request->get['order'])) {
			$url .= '&order=' . $this->request->get['order'];
		}
	 	
		if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}
			 
		if (isset($this->request->post['selected'])) {
			$data['selected'] = (array)$this->request->post['selected'];
		} else {
			$data['selected'] = array();
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('possetting/category_sale', 'user_token=' . $this->session->data['user_token'] . $url, true)
		);



		$data['categoryreports'] = array();

		$filter_data = array(
			'filter_category'   => $filter_category,
			'filter_date_form' => $filter_date_form,
			'filter_date_to' => $filter_date_to,
			'sort'  => $sort,
			'order' => $order,
			'start' => ($page - 1) * $this->config->get('config_limit_admin'),
			'limit' => $this->config->get('config_limit_admin')
		);
		
		$catgs_total = $this->model_possetting_category_sale->getTotalTaxReport($filter_data);
		$results = $this->model_possetting_category_sale->getcategorysaleReports($filter_data);

		foreach ($results as $result) {
		
			$categoryproduct_infos = $this->model_possetting_category_sale->getcategorysaleProducts($result['category_id']);
		
			$products=array();
		
			if(!empty($filter_product)){
				foreach($categoryproduct_infos as $cat_product){
					if(!empty($cat_product['name'])){
						$product_name=$cat_product['name'];
					}	else{
						$product_name='';
					}

					$products[] = array(
						'product_name'    	=> $product_name,
						'product_price'    	=> $this->currency->format($cat_product['price'], $this->config->get('config_currency'), $this->config->get('currency_value'))

					);	
						
				}	
			}

			$data['categoryreports'][] = array(
				'name'    			=> $result['name'],
				'products'    			=> $products,
				'total'             => $this->currency->format($result['total'], $this->config->get('config_currency'), $this->config->get('currency_value'))
			);	
		}

		
		$data['heading_title']        = $this->language->get('heading_title');

		$data['text_list']            = $this->language->get('text_list');
		$data['text_no_results'] 	  = $this->language->get('text_no_results');
		$data['text_confirm'] 		  = $this->language->get('text_confirm');
		$data['text_nooption'] 		  = $this->language->get('text_nooption');
		$data['text_select'] 		  = $this->language->get('text_select');
		$data['text_print'] 		  = $this->language->get('text_print');

		$data['column_order_id']	  = $this->language->get('column_order_id');
		$data['column_product']	      = $this->language->get('column_product');
		$data['column_date']	      = $this->language->get('column_date');
		$data['column_payment_method']= $this->language->get('column_payment_method');
		$data['column_total']  		  =	$this->language->get('column_total');
		$data['column_form']	      = $this->language->get('column_form');
		$data['column_to']	          = $this->language->get('column_to');
		$data['column_grand']	      = $this->language->get('column_grand');

		$data['button_delete'] 		  = $this->language->get('button_delete');
		$data['button_filter'] 		  = $this->language->get('button_filter');
		$data['button_save'] 		  = $this->language->get('button_save');
		$data['user_token']           = $this->session->data['user_token'];
		
		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$url = '';

		if (isset($this->request->get['filter_category'])) {
			$url .= '&filter_category=' . $this->request->get['filter_category'];
		}

		if (isset($this->request->get['filter_date_form'])) {
			$url .= '&filter_date_form=' . $this->request->get['filter_date_form'];
		}

		if (isset($this->request->get['filter_date_to'])) {
			$url .= '&filter_date_to=' . $this->request->get['filter_date_to'];
		}

		if (isset($this->request->get['filter_product'])) {
			$url .= '&filter_product=' . $this->request->get['filter_product'];
		}

		
		if ($order == 'ASC') {
			$url .= '&order=DESC';
		} else {
			$url .= '&order=ASC';
		}

		if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}
		$data['salereports'] = $this->url->link('possetting/category_sale/filterreport', 'user_token=' . $this->session->data['user_token']. $url, true);
	  
		$data['sort_category']		= $this->url->link('possetting/category_sale', 'user_token=' . $this->session->data['user_token'] . '&sort=category' . $url, true);
		$data['sort_total']   		= $this->url->link('possetting/category_sale', 'user_token=' . $this->session->data['user_token'] . '&sort=total' . $url, true);
		
		if (isset($this->session->data['success'])) {
		 $data['success'] = $this->session->data['success'];
		unset($this->session->data['success']);
		} else {
		$data['success'] = '';
		}

		if (isset($this->request->get['filter_order_id'])) {
			$url .= '&filter_order_id=' . $this->request->get['filter_order_id'];
		}

		if (isset($this->request->get['filter_date_form'])) {
			$url .= '&filter_date_form=' . $this->request->get['filter_date_form'];
		}

		if (isset($this->request->get['filter_date_to'])) {
			$url .= '&filter_date_to=' . $this->request->get['filter_date_to'];
		}


		$data['sort']  = $sort;
		$data['order'] = $order;

		$url = '';

		if (isset($this->request->get['filter_order_id'])) {
			$url .= '&filter_order_id=' . $this->request->get['filter_order_id'];
		}

		if (isset($this->request->get['filter_date_form'])) {
			$url .= '&filter_date_form=' . $this->request->get['filter_date_form'];
		}

		if (isset($this->request->get['filter_date_to'])) {
			$url .= '&filter_date_to=' . $this->request->get['filter_date_to'];
		}

		if (isset($this->request->get['sort'])) {
			$url .= '&sort=' . $this->request->get['sort'];
		}

		if (isset($this->request->get['order'])) {
			$url .= '&order=' . $this->request->get['order'];
		}
        
		$pagination 	   = new Pagination();
		$pagination->total = $catgs_total;
		$pagination->page  = $page;
		$pagination->limit = $this->config->get('config_limit_admin');
		$pagination->url   = $this->url->link('possetting/category_sale', 'user_token=' . $this->session->data['user_token'] . $url . '&page={page}', true);
		$data['pagination']= $pagination->render();

		$data['results'] = sprintf($this->language->get('text_pagination'), ($catgs_total) ? (($page - 1) * $this->config->get('config_limit_admin')) + 1 : 0, ((($page - 1) * $this->config->get('config_limit_admin')) > ($catgs_total - $this->config->get('config_limit_admin'))) ? $catgs_total : ((($page - 1) * $this->config->get('config_limit_admin')) + $this->config->get('config_limit_admin')), $catgs_total, ceil($catgs_total / $this->config->get('config_limit_admin')));

		$data['filter_category'] = $filter_category;
		$data['filter_date_form'] = $filter_date_form;
		$data['filter_date_to'] = $filter_date_to;
		$data['filter_product'] = $filter_product;
		$data['sort'] = $sort;
		$data['order'] = $order;

		$data['export'] = $this->url->link('possetting/category_sale/export', 'user_token=' . $this->session->data['user_token']. '&filter_category=' . $filter_category. '&filter_date_form=' . $filter_date_form. '&filter_date_to=' . $filter_date_to. '&filter_product=' . $filter_product);


		$data['header']      = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer']      = $this->load->controller('common/footer');
		$this->response->setOutput($this->load->view('possetting/category_sale', $data));
	}


	public function export() {
		require_once(DIR_SYSTEM.'/library/tmd/PHPExcel.php');

		$this->load->language('possetting/category_sale');	
		$this->load->model('possetting/category_sale');
		$this->load->model('possetting/commission_report');

		if (isset($this->request->get['filter_category'])) {
			$filter_category = $this->request->get['filter_category'];
		} else {
			$filter_category = null;
		}


		if (isset($this->request->get['filter_date_form'])) {
			$filter_date_form = $this->request->get['filter_date_form'];
		} else {
			$filter_date_form = null;
		}

		if (isset($this->request->get['filter_date_to'])) {
			$filter_date_to = $this->request->get['filter_date_to'];
		} else {
			$filter_date_to = null;
		}

		if (isset($this->request->get['filter_product'])) {
			$filter_product = $this->request->get['filter_product'];
		} else {
			$filter_product = null;
		}
		
		if (isset($this->request->get['sort'])) {
			$sort = $this->request->get['sort'];
		} else {
		 	$sort = 'order_id';
		}
	 
		if (isset($this->request->get['order'])) {
			$order = $this->request->get['order'];
		} else {
		 	$order = 'DESC';
		}
	 
		if (isset($this->request->get['page'])) {
			$page = $this->request->get['page'];
		} else {
			$page = 1;
		}

	
		$data = array();

		$filter_data = array(
			'filter_category'   => $filter_category,
			'filter_date_form' => $filter_date_form,
			'filter_date_to' => $filter_date_to,
			'sort'  => $sort,
			'order' => $order,
			'start' => ($page - 1) * $this->config->get('config_limit_admin'),
			'limit' => $this->config->get('config_limit_admin')
		);

		$catgs_total = $this->model_possetting_category_sale->getTotalTaxReport($filter_data);
		$results = $this->model_possetting_category_sale->getcategorysaleReports($filter_data);
		

		foreach ($results as $result) {

			$categoryproduct_infos = $this->model_possetting_category_sale->getcategorysaleProducts($result['category_id']);
		
			$products=array();

			if(!empty($filter_product)){
				foreach($categoryproduct_infos as $cat_product){
					if(!empty($cat_product['name'])){
						$product_name=$cat_product['name'];
					}	else{
						$product_name='';
					}

					$products[] = array(
						'product_name'    	=> $product_name,
						'product_price'    	=> $this->currency->format($cat_product['price'], $this->config->get('config_currency'), $this->config->get('currency_value'))

					);	
						
				}	
			}
		
			$data[] = array(
				'name'    	=> $result['name'],
				'products'    	=> $products,
				'total'     => $this->currency->format($result['total'], $this->config->get('config_currency'), $this->config->get('currency_value'))
			);	
		}


		$objPHPExcel = new PHPExcel();

		// Set properties
		
		$objPHPExcel->getProperties()->setCreator("TMD Export");
		$objPHPExcel->getProperties()->setLastModifiedBy("TMD Export");
		$objPHPExcel->getProperties()->setTitle("Office Excel");
		$objPHPExcel->getProperties()->setSubject("Office Excel");
		$objPHPExcel->getProperties()->setDescription("Office Excel");
		$objPHPExcel->setActiveSheetIndex(0);
		
		$i=1;
		
		$objPHPExcel->getActiveSheet()->SetCellValue('A'.$i, 'Category');
		if(!empty($filter_product)){
		$objPHPExcel->getActiveSheet()->SetCellValue('B'.$i, 'Product');
		$objPHPExcel->getActiveSheet()->SetCellValue('C'.$i, 'Price');
		}
		$objPHPExcel->getActiveSheet()->SetCellValue('D'.$i, 'Total');
		
		$i=2;
		
	

		foreach($data as $catdata) {

			$objPHPExcel->getActiveSheet()->SetCellValue('A'.$i, $catdata['name']);
			$objPHPExcel->getActiveSheet()->SetCellValue('D'.$i, $catdata['total']);
			$i++;
			foreach($catdata['products'] as $product) {			
			$objPHPExcel->getActiveSheet()->SetCellValue('B'.$i, $product['product_name']);
			$objPHPExcel->getActiveSheet()->SetCellValue('C'.$i, $product['product_price']);
			$i++;
			}
			
			
		}


		
		$al='D';
		
		for($col = 'A'; $col != $al; $col++) {
			$objPHPExcel->getActiveSheet()->getColumnDimension($col)->setWidth(20);
		}		
		  
		$excel='Excel5';				
		$filename = 'Category Sale Report.xls';
		$objPHPExcel->getActiveSheet()->setTitle('Category Sale Report');
		$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, $excel);
		$objWriter->save($filename );
		header('Content-type: application/vnd.ms-excel');
		header('Content-Disposition: attachment; filename="'.$filename.'"');
		$objWriter->save('php://output');
		unlink($filename);
	}

public function autocompletecategory() {
		$json = array();

		if (isset($this->request->get['filter_name'])) {
			$this->load->model('possetting/category_sale');

			$filter_data = array(
				'filter_name' => $this->request->get['filter_name'],
				'sort'        => 'name',
				'order'       => 'ASC',
				'start'       => 0,
				'limit'       => 5
			);

			$results = $this->model_possetting_category_sale->getCategories($filter_data);

			foreach ($results as $result) {
				$json[] = array(
					'category_id' => $result['category_id'],
					'name'        => strip_tags(html_entity_decode($result['name'], ENT_QUOTES, 'UTF-8'))
				);
			}
		}

		$sort_order = array();

		foreach ($json as $key => $value) {
			$sort_order[$key] = $value['name'];
		}

		array_multisort($sort_order, SORT_ASC, $json);

		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
	}

	public function autocompleteuser() {
		$json = array();

		if (isset($this->request->get['filter_name'])) {
			$this->load->model('possetting/category_sale');

			if (isset($this->request->get['filter_name'])) {
				$filter_name = $this->request->get['filter_name'];
			} else {
				$filter_name = '';
			}

			if (isset($this->request->get['limit'])) {
				$limit = $this->request->get['limit'];
			} else {
				$limit = 5;
			}

			$filter_data = array(
				'filter_name'  => $filter_name,
				'start'        => 0,
				'limit'        => $limit
			);

			$results = $this->model_possetting_category_sale->getPosusers($filter_data);

				foreach ($results as $result) {

				$json[] = array(
					'user_id' => $result['user_id'],
					'name'      => $result['username']
				);
			}
		}
		

		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
	}

}