<?php
class ModelExtensionCiCustomerGroupProduct extends Model {
	public function getProductsCategories($category_id) {
		$query = $this->db->query("SELECT product_id FROM " . DB_PREFIX . "product_to_category WHERE category_id = '" . (int)$category_id . "'");

		return $query->rows;
	}

	public function getProductsManufacturers($manufacturer_id) {
		$query = $this->db->query("SELECT product_id FROM " . DB_PREFIX . "product WHERE manufacturer_id = '" . (int)$manufacturer_id . "'");

		return $query->rows;
	}

	public function getProductbyCustomergroup($product_id, $customer_group_id) {
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "cigroup_product WHERE product_id = '" . (int)$product_id . "' AND customer_group_id = '" . (int)$customer_group_id . "'");

		return $query->row;
	}

	public function getProducts() {
		$query = $this->db->query("SELECT product_id FROM " . DB_PREFIX . "product WHERE product_id  > 0");

		return $query->rows;
	}

	public function getAllProducts($data = array()) {
		$sql = "SELECT * FROM " . DB_PREFIX . "product p LEFT JOIN " . DB_PREFIX . "product_description pd ON (p.product_id = pd.product_id)";

		if (!empty($data['filter_customer_group'])) {
			$sql .= " LEFT JOIN " . DB_PREFIX . "cigroup_product cp ON (p.product_id = cp.product_id)";
		}

		$sql .= " WHERE pd.language_id = '" . (int)$this->config->get('config_language_id') . "'";

		if (!empty($data['filter_name'])) {
			$sql .= " AND pd.name LIKE '" . $this->db->escape($data['filter_name']) . "%'";
		}

		if (!empty($data['filter_model'])) {
			$sql .= " AND p.model LIKE '" . $this->db->escape($data['filter_model']) . "%'";
		}

		if (isset($data['filter_status']) && !is_null($data['filter_status'])) {
			$sql .= " AND p.status = '" . (int)$data['filter_status'] . "'";
		}

		if (!empty($data['filter_customer_group'])) {
			$sql .= " AND cp.customer_group_id = '" . (int)$data['filter_customer_group'] . "'";
		}

		$sql .= " GROUP BY p.product_id";

		$sort_data = array(
			'pd.name',
			'p.model',
			'p.price',
			'p.quantity',
			'p.status',
			'p.sort_order'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];
		} else {
			$sql .= " ORDER BY pd.name";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = $this->db->query($sql);

		return $query->rows;
	}

	public function getAllTotalProducts($data = array()) {
		$sql = "SELECT COUNT(DISTINCT p.product_id) AS total FROM " . DB_PREFIX . "product p LEFT JOIN " . DB_PREFIX . "product_description pd ON (p.product_id = pd.product_id)";

		if (!empty($data['filter_customer_group'])) {
			$sql .= " LEFT JOIN " . DB_PREFIX . "cigroup_product cp ON (p.product_id = cp.product_id)";
		}

		$sql .= " WHERE pd.language_id = '" . (int)$this->config->get('config_language_id') . "'";

		if (!empty($data['filter_name'])) {
			$sql .= " AND pd.name LIKE '" . $this->db->escape($data['filter_name']) . "%'";
		}

		if (!empty($data['filter_model'])) {
			$sql .= " AND p.model LIKE '" . $this->db->escape($data['filter_model']) . "%'";
		}

		if (isset($data['filter_status']) && !is_null($data['filter_status'])) {
			$sql .= " AND p.status = '" . (int)$data['filter_status'] . "'";
		}

		if (!empty($data['filter_customer_group'])) {
			$sql .= " AND cp.customer_group_id = '" . (int)$data['filter_customer_group'] . "'";
		}

		$query = $this->db->query($sql);

		return $query->row['total'];
	}

	public function getProductids($data) {
		$products = [];

		$exclude_products = isset($data['cigroupproduct_filter_exclude_products']) ? $data['cigroupproduct_filter_exclude_products'] : [];
		if(!empty($data['cigroupproduct_filter_type']) && $data['cigroupproduct_filter_type'] == 'custom_product') {
			$products = $data['cigroupproduct_filter_products'];
		} elseif(!empty($data['cigroupproduct_filter_type']) && $data['cigroupproduct_filter_type'] == 'custom_category') {
			foreach($data['cigroupproduct_categories'] as $category_id) {
				$results = $this->getProductsCategories($category_id);
				foreach($results as $result) {
					if(!in_array($result['product_id'], $exclude_products)) {
						$products[] = $result['product_id'];
					}

				}
			}
			$products = array_unique($products);

		} elseif(!empty($data['cigroupproduct_filter_type']) && $data['cigroupproduct_filter_type'] == 'custom_manufacturer') {
			foreach($data['cigroupproduct_manufacturers'] as $manufacturer_id) {
				$results = $this->getProductsManufacturers($manufacturer_id);
				foreach($results as $result) {
					if(!in_array($result['product_id'],$exclude_products)) {
						$products[] = $result['product_id'];
					}
				}
			}
			$products = array_unique($products);
		} else {
			$allproducts = $this->getProducts();
			foreach ($allproducts as $allproduct) {
				if(!in_array($allproduct['product_id'],$exclude_products)) {
					$products[] = $allproduct['product_id'];
				}
			}
		}

		return $products;
	}

	public function updateProduct($data) {
		$detectupdateproduct = false;
		$products = $this->getProductids($data);

		$enablegroupids = [];
		if (isset($data['cigroupproduct_status'])) {
			foreach ($data['cigroupproduct_status'] as $customer_group_id => $customer_group) {
				if(isset($customer_group['enable'])) {
					$enablegroupids[] = $customer_group_id;
				}
			}
		}

		foreach ($products as $product_id) {
			if (isset($data['cigroupproduct_update_existing']) && $data['cigroupproduct_update_existing']) {
				$this->db->query("DELETE FROM ". DB_PREFIX ."cigroup_product WHERE product_id = '" . (int)$product_id . "'");
				$detectupdateproduct = true;
			}

			if ($enablegroupids) {
				foreach ($enablegroupids as $customer_group_id) {
					$detectupdateproduct = true;
					if (!$this->getProductbyCustomergroup($product_id, $customer_group_id)) {
						$this->db->query("INSERT INTO ". DB_PREFIX ."cigroup_product SET product_id = '" . (int)$product_id . "', customer_group_id = '" . (int)$customer_group_id . "'");
					}
				}
			}
		}

		return $detectupdateproduct;
	}

	public function BuildCiGroupsProduct() {
		$query = $this->db->query("SHOW TABLES LIKE '". DB_PREFIX ."cigroup_product'");
		if(!$query->num_rows) {
			$this->db->query("CREATE TABLE IF NOT EXISTS `". DB_PREFIX ."cigroup_product` (`product_id` int(11) NOT NULL, `customer_group_id` int(11) NOT NULL DEFAULT '0', PRIMARY KEY (`product_id`,`customer_group_id`)) ENGINE=MyISAM DEFAULT CHARSET=utf8");
		}
	}
}