<?php
class ControllerExtensionTmdposCategorySearch extends Controller {
	public function index() {
		$this->load->language('extension/tmdpos/pos');


		if (isset($this->request->get['filter_product'])) {
			$filter_product = $this->request->get['filter_product'];
		} else {
			$filter_product = null;
		}

		$data['poslayout']	= $this->config->get('setting_themechoose');


		$data['filter_product'] = $filter_product;

		return $this->load->view('extension/tmdpos/categorysearch', $data);
	}

	public function autocomplete() {
		$json = array();

		if (isset($this->request->get['filter_product'])) {
			$this->load->model('extension/tmdpos/pos');
			$this->load->model('catalog/option');

			if (isset($this->request->get['filter_product'])) {
				$filter_product = $this->request->get['filter_product'];
			} else {
				$filter_product = '';
			}

			if (isset($this->request->get['limit'])) {
				$limit = $this->request->get['limit'];
			} else {
				$limit = 5;
			}

			$filter_data = array(
				'filter_product'  => $filter_product,
				'start'        => 0,
				'limit'        => $limit
			);

			$results = $this->extension_tmdpos_pos->getProducts($filter_data);

			foreach ($results as $result) {
				$option_data = array();

				$product_options = $this->extension_tmdpos_pos->getProductOptions($result['product_id']);

				foreach ($product_options as $product_option) {
					$option_info = $this->model_catalog_option->getOption($product_option['option_id']);

					if ($option_info) {
						$product_option_value_data = array();

						foreach ($product_option['product_option_value'] as $product_option_value) {
							$option_value_info = $this->model_catalog_option->getOptionValue($product_option_value['option_value_id']);

							if ($option_value_info) {
								$product_option_value_data[] = array(
									'product_option_value_id' => $product_option_value['product_option_value_id'],
									'option_value_id'         => $product_option_value['option_value_id'],
									'name'                    => $option_value_info['name'],
									'price'                   => (float)$product_option_value['price'] ? $this->currency->format($product_option_value['price'], $this->session->data['currency']) : false,
									'price_prefix'            => $product_option_value['price_prefix']
								);
							}
						}

						$option_data[] = array(
							'product_option_id'    => $product_option['product_option_id'],
							'product_option_value' => $product_option_value_data,
							'option_id'            => $product_option['option_id'],
							'name'                 => $option_info['name'],
							'type'                 => $option_info['type'],
							'value'                => $product_option['value'],
							'required'             => $product_option['required']
						);
					}
				}

				$json[] = array(
					'product_id' => $result['product_id'],
					'name'       => strip_tags(html_entity_decode($result['name'], ENT_QUOTES, 'UTF-8')),
					'model'      => $result['model'],
					'option'     => $option_data,
					'price'      => $result['price']
				);
			}
		}

		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
	}
}
