<?php
class ControllerExtensionTmdposForgotten extends Controller {
	private $error = array();

	public function index() {
		if ($this->posuser->isLogged()) {
			$this->response->redirect($this->url->link('extension/tmdpos/pos', '', true));
		}


		$this->load->language('extension/tmdpos/forgotten');
		
		$this->document->setTitle($this->language->get('heading_title'));

		$data['heading_title']=$this->language->get('heading_title');
		$data['entry_email']=$this->language->get('entry_email');
		$data['button_reset']=$this->language->get('button_reset');
		$data['button_cancel']=$this->language->get('button_cancel');

		$this->load->model('extension/tmdpos/user');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$code = token(40);
			$this->model_extension_tmdpos_user->editCode($this->request->post['email'], $code);
			
			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('extension/tmdpos/login', '', true));
		}

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('extension/tmdpos/pos', '', true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/tmdpos/forgotten', 'user_token=' . '', true)
		);
		
		$data['storelogo'] ='';
		$storelogo = $this->config->get('setting_image');
		$logowidth 	= !empty($this->config->get('setting_logowidth'))?$this->config->get('setting_logowidth'):'100';
		$logoheight = !empty($this->config->get('setting_logoheight'))?$this->config->get('setting_logoheight'):'100';
		$this->load->model('tool/image');
		if (!empty($storelogo)) {
			$data['storelogo'] = $this->model_tool_image->resize($storelogo, $logowidth, $logoheight);
		}

		$data['action'] = $this->url->link('extension/tmdpos/forgotten', '', true);

		$data['cancel'] = $this->url->link('extension/tmdpos/login', '', true);

		if (isset($this->request->post['email'])) {
			$data['email'] = $this->request->post['email'];
		} else {
			$data['email'] = '';
		}

		$this->response->setOutput($this->load->view('extension/tmdpos/forgotten', $data));
	}

	protected function validate() {
		if (!isset($this->request->post['email'])) {
			$this->error['warning'] = $this->language->get('error_email');
		} elseif (!$this->model_extension_tmdpos_user->getTotalUsersByEmail($this->request->post['email'])) {
			$this->error['warning'] = $this->language->get('error_email');
		}

		return !$this->error;
	}
}