<?php

class ModelExtensionTmdposReturnReport extends Model {

	public function getReports($data) {

		$sql="SELECT * FROM `" . DB_PREFIX . "pos_order_return` WHERE return_id<>0";
				
		if (!empty($data['filter_product'])) {

			$sql .= " AND name LIKE '%" .$data['filter_product'] . "%'";
		}

		if (!empty($data['filter_product_id_form'])) {

			$sql .= " AND product_id >='" .$data['filter_product_id_form'] . "'";
		}

		if (!empty($data['filter_product_id_to'])) {

			$sql .= " AND product_id <='" .$data['filter_product_id_to'] . "'";
		}

		if (!empty($data['filter_price_form'])) {

			$sql .= " AND price >='" .$data['filter_price_form'] . "'";
		}

		if (!empty($data['filter_model'])) {

			$sql .= " AND model LIKE '%" .$data['filter_model'] . "%'";
		}

		if (!empty($data['filter_price_to'])) {

			$sql .= " AND price <='" .$data['filter_price_to'] . "'";
		}

		if (!empty($data['filter_quantity_form'])) {

			$sql .= " AND quantity >='" .$data['filter_quantity_form'] . "'";
		}

		if (!empty($data['filter_quantity_to'])) {

			$sql .= " AND quantity <='" .$data['filter_quantity_to'] . "'";
		}

		if (!empty($data['filter_date_form'])) {

			$sql .= " AND date(date_added) >='" .$data['filter_date_form'] . "'";
		}

		if (!empty($data['filter_date_to'])) {

			$sql .= " AND date(date_added) <='" .$data['filter_date_to'] . "'";
		}

		if (!empty($data['filter_order_id'])) {

			$sql .= " AND order_id ='" .$data['filter_order_id'] . "'";
		}


		if (isset($data['filter_return_id']) && $data['filter_return_id'] !== '') {
			$sql .= " AND return_id = '" . (int)$data['filter_return_id'] . "'";
		}

		$sort_data = array(

			'product_id',
			'order_id',
			'name',
			'model',
			'price',
			'quantity',
			'date_added',
			'reason',

		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {

			$sql .= " ORDER BY " . $data['sort'];

		} else {

			$sql .= " ORDER BY product_id";

		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {

			$sql .= " DESC";

		} else {

			$sql .= " ASC";

		}

		if (isset($data['start']) || isset($data['limit'])) {

			if ($data['start'] < 0) {

				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {

				$data['limit'] = 20;

			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}
		
		$query = $this->db->query($sql);

		return $query->rows;
	}

	public function deleteReturn($return_id) {
		$this->db->query("DELETE FROM `" . DB_PREFIX . "pos_order_return` WHERE return_id='".$return_id."'");
	}

	public function getTotalReport($data=array()) {
		$sql="SELECT COUNT(*) as total FROM `" . DB_PREFIX . "pos_order_return` WHERE return_id<>0";

		if (!empty($data['filter_product'])) {

			$sql .= " AND name LIKE '%" .$data['filter_product'] . "%'";
		}

		if (!empty($data['filter_product_id_form'])) {

			$sql .= " AND product_id >='" .$data['filter_product_id_form'] . "'";
		}

		if (!empty($data['filter_product_id_to'])) {

			$sql .= " AND product_id <='" .$data['filter_product_id_to'] . "'";
		}

		if (!empty($data['filter_price_form'])) {

			$sql .= " AND price >='" .$data['filter_price_form'] . "'";
		}

		if (!empty($data['filter_model'])) {

			$sql .= " AND model LIKE '%" .$data['filter_model'] . "%'";
		}

		if (!empty($data['filter_price_to'])) {

			$sql .= " AND price <='" .$data['filter_price_to'] . "'";
		}

		if (!empty($data['filter_quantity_form'])) {

			$sql .= " AND quantity >='" .$data['filter_quantity_form'] . "'";
		}

		if (!empty($data['filter_quantity_to'])) {

			$sql .= " AND quantity <='" .$data['filter_quantity_to'] . "'";
		}

		if (!empty($data['filter_date_form'])) {

			$sql .= " AND date(date_added) >='" .$data['filter_date_form'] . "'";
		}

		if (!empty($data['filter_date_to'])) {

			$sql .= " AND date(date_added) <='" .$data['filter_date_to'] . "'";
		}

		if (!empty($data['filter_order_id'])) {

			$sql .= " AND order_id ='" .$data['filter_order_id'] . "'";
		}


		if (isset($data['filter_return_id']) && $data['filter_return_id'] !== '') {
			$sql .= " AND return_id = '" . (int)$data['filter_return_id'] . "'";
		}

		$query = $this->db->query($sql);
		if (!empty($query->num_rows)) {
			return $query->row['total'];
		}else{
			return 0;
		}

	}

	public function getOrder($order_id) {
		$order_query = $this->db->query("SELECT *, (SELECT CONCAT(c.firstname, ' ', c.lastname) FROM " . DB_PREFIX . "customer c WHERE c.customer_id = o.customer_id) AS customer, (SELECT os.name FROM " . DB_PREFIX . "order_status os WHERE os.order_status_id = o.order_status_id AND os.language_id = '" . (int)$this->config->get('config_language_id') . "') AS order_status FROM `" . DB_PREFIX . "order` o WHERE o.order_id = '" . (int)$order_id . "'");

		if ($order_query->num_rows) {
			$country_query = $this->db->query("SELECT * FROM `" . DB_PREFIX . "country` WHERE country_id = '" . (int)$order_query->row['payment_country_id'] . "'");

			if ($country_query->num_rows) {
				$payment_iso_code_2 = $country_query->row['iso_code_2'];
				$payment_iso_code_3 = $country_query->row['iso_code_3'];
			} else {
				$payment_iso_code_2 = '';
				$payment_iso_code_3 = '';
			}

			$zone_query = $this->db->query("SELECT * FROM `" . DB_PREFIX . "zone` WHERE zone_id = '" . (int)$order_query->row['payment_zone_id'] . "'");

			if ($zone_query->num_rows) {
				$payment_zone_code = $zone_query->row['code'];
			} else {
				$payment_zone_code = '';
			}

			$country_query = $this->db->query("SELECT * FROM `" . DB_PREFIX . "country` WHERE country_id = '" . (int)$order_query->row['shipping_country_id'] . "'");

			if ($country_query->num_rows) {
				$shipping_iso_code_2 = $country_query->row['iso_code_2'];
				$shipping_iso_code_3 = $country_query->row['iso_code_3'];
			} else {
				$shipping_iso_code_2 = '';
				$shipping_iso_code_3 = '';
			}

			$zone_query = $this->db->query("SELECT * FROM `" . DB_PREFIX . "zone` WHERE zone_id = '" . (int)$order_query->row['shipping_zone_id'] . "'");

			if ($zone_query->num_rows) {
				$shipping_zone_code = $zone_query->row['code'];
			} else {
				$shipping_zone_code = '';
			}

			$reward = 0;

			$order_product_query = $this->db->query("SELECT * FROM " . DB_PREFIX . "order_product WHERE order_id = '" . (int)$order_id . "'");

			foreach ($order_product_query->rows as $product) {
				$reward += $product['reward'];
			}
			
			$this->load->model('extension/tmdpos/customer');

			$affiliate_info = $this->model_extension_tmdpos_customer->getCustomer($order_query->row['affiliate_id']);

			if ($affiliate_info) {
				$affiliate_firstname = $affiliate_info['firstname'];
				$affiliate_lastname = $affiliate_info['lastname'];
			} else {
				$affiliate_firstname = '';
				$affiliate_lastname = '';
			}

			$this->load->model('localisation/language');

			$language_info = $this->model_localisation_language->getLanguage($order_query->row['language_id']);

			if ($language_info) {
				$language_code = $language_info['code'];
			} else {
				$language_code = $this->config->get('config_language');
			}

			return array(
				'order_id'                => $order_query->row['order_id'],
				'invoice_no'              => $order_query->row['invoice_no'],
				'invoice_prefix'          => $order_query->row['invoice_prefix'],
				'store_id'                => $order_query->row['store_id'],
				'store_name'              => $order_query->row['store_name'],
				'store_url'               => $order_query->row['store_url'],
				'customer_id'             => $order_query->row['customer_id'],
				'customer'                => $order_query->row['customer'],
				'customer_group_id'       => $order_query->row['customer_group_id'],
				'firstname'               => $order_query->row['firstname'],
				'lastname'                => $order_query->row['lastname'],
				'email'                   => $order_query->row['email'],
				'telephone'               => $order_query->row['telephone'],
				'custom_field'            => json_decode($order_query->row['custom_field'], true),
				'payment_firstname'       => $order_query->row['payment_firstname'],
				'payment_lastname'        => $order_query->row['payment_lastname'],
				'payment_company'         => $order_query->row['payment_company'],
				'payment_address_1'       => $order_query->row['payment_address_1'],
				'payment_address_2'       => $order_query->row['payment_address_2'],
				'payment_postcode'        => $order_query->row['payment_postcode'],
				'payment_city'            => $order_query->row['payment_city'],
				'payment_zone_id'         => $order_query->row['payment_zone_id'],
				'payment_zone'            => $order_query->row['payment_zone'],
				'payment_zone_code'       => $payment_zone_code,
				'payment_country_id'      => $order_query->row['payment_country_id'],
				'payment_country'         => $order_query->row['payment_country'],
				'payment_iso_code_2'      => $payment_iso_code_2,
				'payment_iso_code_3'      => $payment_iso_code_3,
				'payment_address_format'  => $order_query->row['payment_address_format'],
				'payment_custom_field'    => json_decode($order_query->row['payment_custom_field'], true),
				'payment_method'          => $order_query->row['payment_method'],
				'payment_code'            => $order_query->row['payment_code'],
				'shipping_firstname'      => $order_query->row['shipping_firstname'],
				'shipping_lastname'       => $order_query->row['shipping_lastname'],
				'shipping_company'        => $order_query->row['shipping_company'],
				'shipping_address_1'      => $order_query->row['shipping_address_1'],
				'shipping_address_2'      => $order_query->row['shipping_address_2'],
				'shipping_postcode'       => $order_query->row['shipping_postcode'],
				'shipping_city'           => $order_query->row['shipping_city'],
				'shipping_zone_id'        => $order_query->row['shipping_zone_id'],
				'shipping_zone'           => $order_query->row['shipping_zone'],
				'shipping_zone_code'      => $shipping_zone_code,
				'shipping_country_id'     => $order_query->row['shipping_country_id'],
				'shipping_country'        => $order_query->row['shipping_country'],
				'shipping_iso_code_2'     => $shipping_iso_code_2,
				'shipping_iso_code_3'     => $shipping_iso_code_3,
				'shipping_address_format' => $order_query->row['shipping_address_format'],
				'shipping_custom_field'   => json_decode($order_query->row['shipping_custom_field'], true),
				'shipping_method'         => $order_query->row['shipping_method'],
				'shipping_code'           => $order_query->row['shipping_code'],
				'comment'                 => $order_query->row['comment'],
				'total'                   => $order_query->row['total'],
				'reward'                  => $reward,
				'order_status_id'         => $order_query->row['order_status_id'],
				'order_status'            => $order_query->row['order_status'],
				'affiliate_id'            => $order_query->row['affiliate_id'],
				'affiliate_firstname'     => $affiliate_firstname,
				'affiliate_lastname'      => $affiliate_lastname,
				'commission'              => $order_query->row['commission'],
				'language_id'             => $order_query->row['language_id'],
				'language_code'           => $language_code,
				'currency_id'             => $order_query->row['currency_id'],
				'currency_code'           => $order_query->row['currency_code'],
				'currency_value'          => $order_query->row['currency_value'],
				'ip'                      => $order_query->row['ip'],
				'forwarded_ip'            => $order_query->row['forwarded_ip'],
				'user_agent'              => $order_query->row['user_agent'],
				'accept_language'         => $order_query->row['accept_language'],
				'date_added'              => $order_query->row['date_added'],
				'date_modified'           => $order_query->row['date_modified']
			);
		} else {
			return;
		}
	}

	public function getOrderOptions($order_id, $order_product_id) {
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "order_option WHERE order_id = '" . (int)$order_id . "' AND order_product_id = '" . (int)$order_product_id . "'");

		return $query->rows;
	}


}