<?php
namespace Cart;
class PosUser {
	private $user_id;
	private $firstname;
	private $lastname;
	private $email;
	private $image;
	private $user_group_id;
	private $username;
	private $db;
	private $request;
	private $session;
	private $permission = array();

	public function __construct($registry) {
		$this->db = $registry->get('db');
		$this->request = $registry->get('request');
		$this->session = $registry->get('session');

		if (isset($this->session->data['pos_user_id'])) {
			$user_query = $this->db->query("SELECT * FROM " . DB_PREFIX . "pos_user WHERE user_id = '" . (int)$this->session->data['pos_user_id'] . "' AND status = '1'");

			if ($user_query->num_rows) {
				$this->session->data['store_id'] = $user_query->row['user_store_id'];
				$this->user_id = $user_query->row['user_id'];
				$this->username = $user_query->row['username'];
				$this->firstname = $user_query->row['firstname'];
				$this->lastname = $user_query->row['lastname'];
				$this->email = $user_query->row['email'];
				$this->image = $user_query->row['image'];

				$this->db->query("UPDATE " . DB_PREFIX . "pos_user SET ip = '" . $this->db->escape($this->request->server['REMOTE_ADDR']) . "' WHERE user_id = '" . (int)$this->session->data['pos_user_id'] . "'");

			} else {
				$this->logout();
			}
		}
	}

	public function login($username, $password) {
		$user_query = $this->db->query("SELECT * FROM " . DB_PREFIX . "pos_user WHERE username = '" . $this->db->escape($username) . "' AND (password = SHA1(CONCAT(salt, SHA1(CONCAT(salt, SHA1('" . $this->db->escape($password) . "'))))) OR password = '" . $this->db->escape(md5($password)) . "') AND status = '1'");

		if ($user_query->num_rows) {
			$this->session->data['pos_user_id'] = $user_query->row['user_id'];

			$this->session->data['store_id'] = $user_query->row['user_store_id'];
			$this->user_id = $user_query->row['user_id'];
			$this->username = $user_query->row['username'];
			$this->firstname = $user_query->row['firstname'];
			$this->lastname = $user_query->row['lastname'];
			$this->email = $user_query->row['email'];
			$this->image = $user_query->row['image'];

			return true;
		} else {
			return false;
		}
	}

	public function logout() {
		unset($this->session->data['pos_user_id']);

		$this->user_id = '';
		$this->username = '';
	}

	

	public function isLogged() {
		return $this->user_id;
	}

	public function getId() {
		return $this->user_id;
	}

	public function getUserName() {
		return $this->username;
	}

	public function getGroupId() {
		return $this->user_group_id;
	}

	public function getFirstName() {
		return $this->firstname;
	}

	public function getLastName() {
		return $this->lastname;
	}

	public function getEmail() {
		return $this->email;
	}

	public function getProfilePic() {
		return $this->image;
	}
}